package aspectEditor.aspectEditorUtils;
import java.util.jar.JarFile;
import java.util.*;
import java.io.*;
import edu.neu.ccs.demeter.aplib.*;
import edu.neu.ccs.demeter.*;
class PartNameExact extends PartNameGlob {
  protected PartName partname;
  public PartName get_partname() { return partname; }
  public void set_partname(PartName new_partname) { partname = new_partname; }
  public PartNameExact() { super(); }
  public PartNameExact(PartName partname) {
    super();
    set_partname(partname);
  }
  public static PartNameExact parse(java.io.Reader in) throws ParseException { return new Parser(in)._PartNameExact(); }
  public static PartNameExact parse(java.io.InputStream in) throws ParseException { return new Parser(in)._PartNameExact(); }
  public static PartNameExact parse(String s) {
    try { return parse(new java.io.StringReader(s)); }
    catch (ParseException e) {
      throw new RuntimeException(e.toString());
    }
  }
  void universal_trv0_bef(UniversalVisitor _v_) {
    super.universal_trv0_bef(_v_);
    ((UniversalVisitor) _v_).before(this);
  }

  void universal_trv0_aft(UniversalVisitor _v_) {
    ((UniversalVisitor) _v_).after(this);
    super.universal_trv0_aft(_v_);
  }

  void universal_trv0(UniversalVisitor _v_) {
    universal_trv0_bef(_v_);
    ((UniversalVisitor) _v_).before_partname(this, partname);
    partname.universal_trv0(_v_);
    ((UniversalVisitor) _v_).after_partname(this, partname);
    super.universal_trv0(_v_);
    universal_trv0_aft(_v_);
  }

  void __trav_matchEdge_GlobSpec_trv_bef(__V_GlobSpec_matchEdge __v0) {
    super.__trav_matchEdge_GlobSpec_trv_bef(__v0);
  }

  void __trav_matchEdge_GlobSpec_trv_aft(__V_GlobSpec_matchEdge __v0) {
    super.__trav_matchEdge_GlobSpec_trv_aft(__v0);
  }

  void __trav_matchEdge_GlobSpec_trv(__V_GlobSpec_matchEdge __v0) {
    __trav_matchEdge_GlobSpec_trv_bef(__v0);
    partname.__trav_matchEdge_GlobSpec_trv(__v0);
    __trav_matchEdge_GlobSpec_trv_aft(__v0);
  }

}
